# mypy-boto3-snowball

[![PyPI - mypy-boto3-snowball](https://img.shields.io/pypi/v/mypy-boto3-snowball.svg?color=blue)](https://pypi.org/project/mypy-boto3-snowball)
[![PyPI - Python Version](https://img.shields.io/pypi/pyversions/mypy-boto3-snowball.svg?color=blue)](https://pypi.org/project/mypy-boto3-snowball)
[![Docs](https://img.shields.io/readthedocs/mypy-boto3-builder.svg?color=blue)](https://mypy-boto3-builder.readthedocs.io/)

- [mypy-boto3-snowball](#mypy-boto3-snowball)
  - [How to use](#how-to-use)
  - [Automated type discovery](#automated-type-discovery)


Type annotations for
[boto3.Snowball 1.13.26](https://boto3.amazonaws.com/v1/documentation/api/1.13.26/reference/services/snowball.html#Snowball) service
compatible with [mypy](https://github.com/python/mypy), [VSCode](https://code.visualstudio.com/),
[PyCharm](https://www.jetbrains.com/pycharm/) and other tools.

Generated by [mypy-boto3-buider 2.0.3](https://github.com/vemel/mypy_boto3_builder).

More information can be found on [boto3-stubs](https://pypi.org/project/boto3-stubs/) page.

- [mypy-boto3-snowball](#mypy-boto3-snowball)
  - [How to use](#how-to-use)
    - [Type checking](#type-checking)
  - [How it works](#how-it-works)

## How to use

Make sure you have [mypy](https://github.com/python/mypy) installed and activated in your IDE.

Install `boto3-stubs` for `Snowball` service.

```bash
python -m pip install boto3-stubs[snowball]

# update installed packages index for automated type discovery
python -m mypy_boto3
```

Use `boto3` with `mypy_boto3_snowball` in your project and enjoy type checking and auto-complete.

```python
import boto3

from mypy_boto3_snowball import SnowballClient

# Now mypy can check if your code is valid.
client: SnowballClient = boto3.client("snowball")

# works for session as well
session = boto3.session.Session(region="us-west-1")
session_client: SnowballClient = session.client("snowball")



# Annotated paginators are included as well

import mypy_boto3_snowball.paginator as snowball_paginators

describe_addresses_paginator: snowball_paginators.DescribeAddressesPaginator = client.get_paginator("describe_addresses")
list_cluster_jobs_paginator: snowball_paginators.ListClusterJobsPaginator = client.get_paginator("list_cluster_jobs")
list_clusters_paginator: snowball_paginators.ListClustersPaginator = client.get_paginator("list_clusters")
list_compatible_images_paginator: snowball_paginators.ListCompatibleImagesPaginator = client.get_paginator("list_compatible_images")
list_jobs_paginator: snowball_paginators.ListJobsPaginator = client.get_paginator("list_jobs")
```

## Automated type discovery

`mypy_boto3` package can generate index for `mypy_boto3_snowball` and other installed services.

```bash
# Run this command when you add or remove service packages
python -m mypy_boto3
```

Generated index provides overloads for `boto3.client` and `boto3.service`,
`boto3.Session.client` and `boto3.Session.resource` functions,
so explicit type annotations are not needed.

- `mypy` supports function overloads as expected
- `PyCharm` also supports function overloads, but consumes a lot of RAM, use carefully
- `VSCode` does not currently support function overloads

Also, generated index allows you to import types from `mypy_boto3`:

```python
# you can replace imports
import mypy_boto3_snowball as snowball
from mypy_boto3_snowball import SnowballClient

# with these
from mypy_boto3 import snowball
from mypy_boto3.snowball import SnowballClient
```